import { describe, expect, it, vi } from 'vitest';
import { Debounce } from './debounce';

describe('debounce', () => {
    it('cancels existing callback if a new one is created', () => {
        vi.useFakeTimers();
        const mockFn = vi.fn();

        const debounce = new Debounce();

        debounce.debounce(() => mockFn(), 500);
        debounce.debounce(() => mockFn(), 500);
        debounce.debounce(() => mockFn(), 500);
        debounce.debounce(() => mockFn(), 500);
        debounce.debounce(() => mockFn(), 500);

        vi.advanceTimersByTime(1000);

        expect(mockFn).toBeCalledTimes(1);
    });
});